#! /usr/bin/env python3
#
# About program:
# Simple password generator
# Program for generate passwords
__version__ = '1.0'
__author__ = 'Karpukhin Pavel <---my@mail.com--->'
__license__ = 'Public Domain'
#__url__ = 'http://---.ru'
#

# Import needed modules
import secrets
import os
import math
import locale
from os import system
from os import name
#####


# Script colorization (by os.name)
class TxtColors:
    # for Windows
    if name == 'nt':
        ColorEND = ''
        ColorRED = ''
        ColorGREEN = ''
        ColorYELLOW = ''
        ColorBLUEBG = ''
        ColorBLUE = ''
        ColorWHITE = ''
    # for Linux
    else:
        ColorEND = '\33[0m'
        ColorRED = '\33[31m'
        ColorGREEN = '\33[32m'
        ColorYELLOW = '\33[33m'
        ColorBLUEBG = '\33[44m'
        ColorBLUE = '\33[34m'
        ColorWHITE = '\33[37m'


# Clear screen (by os.name)
def clear():
    # for Windows
    if name == 'nt':
        _ = system('cls')
    # for Linux
    else:
        _ = system('clear')


# Get system locale
locale.setlocale(locale.LC_ALL, "")
if name == 'nt':
    sys_locale = locale.getlocale()[0]
else:
    sys_locale = locale.getlocale(locale.LC_MESSAGES)[0]


# Localization programm (by OS locale)
class TxtLocales:
    # for Linux Russian language
    if sys_locale == 'ru_RU':
        TextMessage01 = 'Генератор простых паролей'
        TextMessage02 = 'Хотите повторить? [Yes | No]: \n'
        TextMessage03 = 'Сколько паролей вы планируете сгенерировать? '
        TextMessage04 = '\nВводите только цифры.\nРабота завершена.'
        TextMessage05 = 'Из скольких символов сгенерировать пароль? '
        TextMessage06 = 'Нехватает данных для расчёта...'
        TextMessage07 = 'Запрошено паролей - '
        TextMessage08 = 'Длина в символах  - '
        TextMessage09 = 'Предлагаю следующие варианты: \n'
        TextMessage10 = '\nПожалуйста.'
        TextMessage11 = 'Заходите ещё! '
        TextMessage12 = 'Вариант №'
    # For Windows Russian language
    elif sys_locale == 'Russian_Russia':
        TextMessage01 = 'Генератор простых паролей'
        TextMessage02 = 'Хотите повторить? [Yes | No]: \n'
        TextMessage03 = 'Сколько паролей вы планируете сгенерировать? '
        TextMessage04 = '\nВводите только цифры.\nРабота завершена.'
        TextMessage05 = 'Из скольких символов сгенерировать пароль? '
        TextMessage06 = 'Нехватает данных для расчёта...'
        TextMessage07 = 'Запрошено паролей - '
        TextMessage08 = 'Длина в символах  - '
        TextMessage09 = 'Предлагаю следующие варианты: \n'
        TextMessage10 = '\nПожалуйста.'
        TextMessage11 = 'Заходите ещё! '
        TextMessage12 = 'Вариант №'
    # for Other languages
    else:
        TextMessage01 = 'Simple password generator'
        TextMessage02 = 'Are you want repeat? [Yes | No]: \n'
        TextMessage03 = 'How many passwords generate for you? '
        TextMessage04 = '\nUse only digits.\nProgramm closed by input error.'
        TextMessage05 = 'How many chracters to use to generate a password? '
        TextMessage06 = 'There is not enough data for calculation...'
        TextMessage07 = 'Password requested - '
        TextMessage08 = 'Length in characters - '
        TextMessage09 = 'I suggest the following variants: \n'
        TextMessage10 = '\nYou are welcome.'
        TextMessage11 = 'Come again! '
        TextMessage12 = 'Variant #'


# Print program name
def program_name():
    print(TxtColors.ColorBLUEBG + TxtLocales.TextMessage01 + TxtColors.ColorEND + '\n')


# Rerun program
def replay():
    return input(TxtLocales.TextMessage02).lower().startswith('y')


# Number of passwords
def pwd_count():
    pwds = 0
    pwd_massive = list(range(1,100))
    try:
        while int(pwds) not in pwd_massive:
            pwds = input(TxtLocales.TextMessage03)
    except ValueError:
        print(TxtColors.ColorRED + TxtLocales.TextMessage04 + TxtColors.ColorEND)
        exit()
    else:
        return int(pwds)


# Number of characters in password
def pwd_chars():
    chrs = 0
    chr_massive = list(range(1,50))
    try:
        while int(chrs) not in chr_massive:
            chrs = input(TxtLocales.TextMessage05)
    except ValueError:
        print(TxtColors.ColorRED + TxtLocales.TextMessage04 + TxtColors.ColorEND)
        exit()
    else:
        return int(chrs)


def genpwrds(chrs):
    if chrs > 0:
        # token_urlsafe use bytes in Bsae64 encoding. 1 byte is 1.3 character.
        password = secrets.token_urlsafe(chrs)
    else:
        password = TxtLocales.TextMessage06
    return str(password)


while True:
    # Clear screen and start program
    clear()
    program_name()
    game_on = True
    i = 1
    count_passwords_view = pwd_count()
    count_passwords = count_passwords_view + 1
    count_chars =  pwd_chars()

    while game_on:
        clear()
        program_name()
        print(TxtLocales.TextMessage07 + TxtColors.ColorYELLOW + str(count_passwords_view) + TxtColors.ColorEND)
        print(TxtLocales.TextMessage08 + TxtColors.ColorYELLOW + str(count_chars) + TxtColors.ColorEND)
        print('===================================\n')
        print(TxtLocales.TextMessage09)
        for i in range(i, count_passwords, 1):
            generated_password = genpwrds(count_chars)
            print(TxtLocales.TextMessage12 + str(i) + ': ' + TxtColors.ColorGREEN + str(generated_password[-count_chars:]) + TxtColors.ColorEND)
            
            game_on = False
        print('===================================\n')

            
    if not replay():
        print(TxtLocales.TextMessage10)
        print(TxtLocales.TextMessage11 + TxtColors.ColorRED + ';)' + TxtColors.ColorEND)
        break
